<Query Kind="Program" />

void Main()
{
	var customers = new[]
	{
		new { ID = 1, Name = "John" },
		new { ID = 2, Name = "Mary" },
		new { ID = 3, Name = "Hank" }
	};
	
	var purchases = new[]
	{
		 new { Product = "Tablet", CustomerID = 1 },
		 new { Product = "iPhone", CustomerID = 2 },
		 new { Product = "LINQPad", CustomerID = 2 },
		 new { Product = "Resharper", CustomerID = 3 }
	};
	
	var query = Join (
		customers,  purchases, 
    	c => c.ID,  p => p.CustomerID, 
       (c,          p)                 => (c.Name + " bought a ") + p.Product);
	   
	query.Dump();
}

IEnumerable<TResult> Join<TOuter, TInner, TKey, TResult> (
	IEnumerable<TOuter> outer,
	IEnumerable<TInner> inner,
	Func<TOuter, TKey> outerKeySelector,
	Func<TInner, TKey> innerKeySelector,
	Func<TOuter, TInner, TResult> resultSelector)
{
	var lookup = inner.ToLookup (innerKeySelector);

	return
		from o in outer
		from i in lookup [outerKeySelector (o)]
		select resultSelector (o, i);
}