<Query Kind="Program" />

void Main()
{
	string[] names = { "Michael", "Jennifer", "Clementine", "Marcus" };
	
	Where (names, n => n.StartsWith ("M")).Dump();
}

IEnumerable<T> Where<T> (IEnumerable<T> input, Func<T, bool> predicate)
{
	return input.SelectMany (
		element => predicate (element) 
			? new[] { element } 
			: new T[0]);
}