<Query Kind="Program" />

void Main()
{
	new[] { 1, 2, 3 }.Bind (x => x * 2).Dump();
}

static class Extensions
{
	public static IEnumerable<T> ToEnumerable<T> (this T element)
	{
		return Enumerable.Repeat (element, 1);
	}
	
	public static IEnumerable<U> Bind<T,U> (this IEnumerable<T> sequence, Func<T,U> func) 
	{
		foreach (var element in sequence)
			yield return func (element);
	}
	
	public static Nullable<U> Bind<T,U> (this Nullable<T> input, Func<T, Nullable<U>> func)
	{
		if (!value.HasValue) return default(Nullable<U>);
		return func(value.Value);
	}
}