<Query Kind="Program" />

void Main()
{
	string[] names = { "Michael", "Jennifer", "Clementine", "Marcus" };
	
	names.CriminalBind (s => s.ToCharArray()).Dump();
}

static class Extensions
{
	public static IEnumerable<T> ToEnumerable<T> (this T element)
	{
		return Enumerable.Repeat (element, 1);
	}
	
	public static IEnumerable<U> CriminalBind<T,U> (this IEnumerable<T> input, Func<T, IEnumerable<U>> func)
	{
		foreach (var element in input)
			foreach (var subElement in func(element))
				yield return subElement;
	}
}