<Query Kind="Program" />

void Main()
{
	Test2 (3).Dump();
}

NullableInt Test2 (NullableInt x)
{
	return x.Bind (n => n * 2)
			.Bind (n => n + 1);
}

struct NullableInt
{
	readonly bool _hasValue;
	readonly int _value;	

	public NullableInt (int value) { _value = value; _hasValue = true; }  // Unit Function
	
	public static implicit operator NullableInt (int value) { return new NullableInt (value); }
	
	public readonly static NullableInt Null = default (NullableInt);
	
	public bool HasValue { get { return _hasValue; } }
	
	public int Value   // Extract Function
	{
		get
		{
			if (!_hasValue) throw new NullReferenceException();
			return _value;
		}
	}
	
	public NullableInt Bind (Func<int,int> func)
	{
		if (!_hasValue) return Null;
		return (NullableInt) func (_value);
	}
}