<Query Kind="Program" />

void Main()
{	
	Test2 (3).Dump();
}

int Test1 (int x)
{
	int y = x * 2;
	int z = y + 1;
	return z;
}

NullableInt Test2 (NullableInt x)
{
	NullableInt y = x.HasValue ? x.Value * 2 : NullableInt.Null;
	NullableInt z = y.HasValue ? y.Value + 1 : NullableInt.Null;
	return z;
}

struct NullableInt
{
	readonly bool _hasValue;
	readonly int _value;	

	public NullableInt (int value) { _value = value; _hasValue = true; }  // Unit Function
	
	public static implicit operator NullableInt (int value) { return new NullableInt (value); }
	
	public readonly static NullableInt Null = default (NullableInt);
	
	public bool HasValue { get { return _hasValue; } }
	
	public int Value   // Extract Function
	{
		get
		{
			if (!_hasValue) throw new NullReferenceException();
			return _value;
		}
	}
}