<Query Kind="Program" />

void Main()
{
	NullableInt x = 3;
	NullableInt y = 4;

	NullableInt z = x.Bind (n => y.Bind (m => n * m));
	z.Dump();
}

struct NullableInt
{
	readonly bool _hasValue;
	readonly int _value;	

	public NullableInt (int value) { _value = value; _hasValue = true; }  // Unit Function
	
	public static implicit operator NullableInt (int value) { return new NullableInt (value); }
	
	public readonly static NullableInt Null = default (NullableInt);
	
	public bool HasValue { get { return _hasValue; } }
	
	public int Value   // Extract Function
	{
		get
		{
			if (!_hasValue) throw new NullReferenceException();
			return _value;
		}
	}
	
	public NullableInt Bind (Func<int,int> func)
	{
		if (!_hasValue) return Null;
		return (NullableInt) func (_value);
	}
	
	public NullableInt Bind (Func<int,NullableInt> func)
	{
		if (!_hasValue) return Null;
		return func (_value);
	}
}