<Query Kind="Program" />

void Main()
{
	GetGenericTypeDef (typeof (int?)).Dump();
	GetFirstTypeArg   (typeof (int?)).Dump();
	MakeGenericListType (typeof (string)).Dump();
}

static Func<TIn,TOut> Memoize<TIn,TOut> (Func<TIn,TOut> func)
{
	var cache = new Dictionary<TIn,TOut>();
	return (input =>
	{
		TOut result;
		if (cache.TryGetValue (input, out result)) return result;
		return cache[input] = func (input);
	});
}

readonly Func<Type,Type>
	GetGenericTypeDef   = Memoize<Type,Type> (t => t.GetGenericTypeDefinition()),
	GetFirstTypeArg     = Memoize<Type,Type> (t => t.GetGenericArguments()[0]),
	MakeGenericListType = Memoize<Type,Type> (t => typeof(List<>).MakeGenericType (t));