<Query Kind="Program" />

void Main()
{
	var memoizer = Memoize<int,int> (Expensive);
	memoizer (2).Dump();
	memoizer (2).Dump();
	memoizer (2).Dump();
}

int Expensive (int x) { Thread.Sleep(2000); return x * 10; }

Func<TIn,TOut> Memoize<TIn,TOut> (Func<TIn,TOut> func)
{
	var cache = new Dictionary<TIn,TOut>();
	return (input =>
	{
		TOut result;
		if (cache.TryGetValue (input, out result)) return result;
		return cache[input] = func (input);
	});
}