<Query Kind="Program" />

void Main()
{
	var memoizer = new Memoizer (Expensive);
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
}

int Expensive (int x) { Thread.Sleep(2000); return x * 10; }

class Memoizer
{
	readonly Dictionary<int,int> _cache = new Dictionary<int,int>();
	readonly Func<int, int> _func;
	
	public Memoizer (Func<int, int> func) { _func = func; }
	
	public int GetValue (int x)
	{
		int result;
		if (_cache.TryGetValue (x, out result)) return result;
		return _cache[x] = _func (x);
	}
}