<Query Kind="Program" />

void Main()
{
	var memoizer = new Memoizer<int,int> (Expensive);
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
}

int Expensive (int x) { Thread.Sleep(2000); return x * 10; }

class Memoizer<TIn,TOut>
{
	readonly Dictionary<TIn,TOut> _cache = new Dictionary<TIn,TOut>();
	readonly Func<TIn, TOut> _func;
	
	public Memoizer (Func<int, int> func) { _func = func; }
	
	public TOut GetValue (TIn x)
	{
		TOut result;
		if (_cache.TryGetValue (x, out result)) return result;
		return _cache[x] = _func (x);
	}
}